/**
 *   @author          Black Cat Development
 *   @copyright       2013, Black Cat Development
 *   @link            http://blackcat-cms.org
 *   @license         http://www.gnu.org/licenses/gpl.html
 *   @category        CAT_Core
 *   @package         freshcat
  *
 */

jQuery(document).ready(function($)
{

    // map button classes to addon types
    var map_buttons = {
        'icon-puzzle': 'type_modules',
        'icon-color-palette': 'type_templates',
        'icon-comments': 'type_languages',
        'icon-folder-add': 'not_installed'
    };

    function reset_addons_list()
    {
        // remove all markups (including buttons)
        $('#fc_list_overview').children('li').removeClass('fc_active');
        // get currently active button
        var classes = $('#fc_lists_overview button.fc_active').attr("class").split(" ").filter(function(item) {
            return item.indexOf("icon") === -1 ? "" : item;
        });
        // hide all but current
        if(map_buttons[classes[0]] !== 'not_installed') {
            $('.fc_not_installed').addClass('fc_no_search').slideUp(0);
        }
   	    $('#fc_list_overview').children('li').not('.fc_'+map_buttons[classes[0]]).addClass('fc_no_search').slideUp(0);
        // re-activate current
        $('#fc_lists_overview button.fc_'+map_buttons[classes[0]]).removeClass('fc_no_search').addClass('fc_active');
        $('#fc_list_search_input').blur();
    }

    $('#fc_list_overview li').fc_set_tab_list();

    // on init: hide all but modules
	reset_addons_list();

    // show addon details
    $('.fc_module_item').not('.fc_type_heading').click( function(e) {
        var current	= $(this);
        var dates	= {
			'_cat_ajax': 1,
            'module'   : current.find('input[name="addon_directory"]').val(),
            'type'     : current.find('input[name="addon_type"]').val()
		};
		$.ajax(
		{
			type:		'POST',
			url:		CAT_ADMIN_URL + '/addons/ajax_get_details.php',
			dataType:	'json',
			data:		dates,
			cache:		false,
            beforeSend:	function( data )
    		{
    			data.process	= set_activity();
    		},
			success:	function( data, textStatus, jqXHR )
			{
				if ( data.success === true )
				{
                    $('div#addon_details').html(data.content);
                    jqXHR.process.slideUp(1200, function(){ jqXHR.process.remove(); });
				}
				else {
					return_error( jqXHR.process , data.message);
				}
			}
		});
    });

    // (un)hide add module form
    $('#fc_add_new_module_button').click(
        function(e) {
            $('#fc_add_new_module').toggle('slow');
            e.preventDefault();
        }
    );

    // override search label
    $('label.fc_close').click( function() {
        reset_addons_list();
    });

   	$('#fc_lists_overview button').not('#fc_list_add').click( function()
	{
		var current_button	= $(this);
        var classes = current_button.attr("class").split(" ").filter(function(item) {
            return item.indexOf("icon") === -1 ? "" : item;
        });
        // deactivate buttons
        $('#fc_lists_overview button').not('#fc_list_add').removeClass('fc_active');
        // activate current
        current_button.toggleClass('fc_active');
        // hide all
        $('#fc_list_overview').children('li').addClass('fc_no_search').slideUp(300);
        // show selected
        $('#fc_list_overview').children('li.fc_' + map_buttons[classes[0]] ).removeClass('fc_no_search').slideDown(300);
	});

	$('#fc_mark_all').click( function(e)
	{
		e.preventDefault();
		var current		= $(this),
			input_div	= $('#fc_perm_groups');
		current.toggleClass( 'fc_marked' );
		if ( current.hasClass( 'fc_marked' ) )
		{
			input_div.children( 'input' ).prop( 'checked', true).change();
			current.children( '.fc_mark' ).addClass('hidden');
			current.children( '.fc_unmark' ).removeClass('hidden');
		}
		else
		{
			input_div.children( 'input' ).prop( 'checked', false).change();
			current.children( '.fc_unmark' ).addClass('hidden');
			current.children( '.fc_mark' ).removeClass('hidden');
		}
	});

});